/*
 * Copyright Red Hat Inc. and/or its affiliates and other contributors
 * as indicated by the authors tag. All rights reserved.
 *
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License version 2.
 * 
 * This particular file is subject to the "Classpath" exception as provided in the 
 * LICENSE file that accompanied this code.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License,
 * along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */
package com.redhat.ceylon.compiler;

import com.redhat.ceylon.common.tool.ToolError;

/**
 * Exception type used when compilation could not complete normally due to 
 * errors in the source code, such as syntax or type errors. 
 */
public class CompilerErrorException extends ToolError {

    private final int numErrors;

    CompilerErrorException(int numErrors) {
        super(CeylonCompileMessages.msgCompilerErrors(numErrors));
        this.numErrors = numErrors;
    }
    
    /** The number of errors */
    public int getNumErrors() {
        return numErrors;
    }

}
